"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loadDirectory = loadDirectory;

var fs = _interopRequireWildcard(require("fs"));

var path = _interopRequireWildcard(require("path"));

var _escapeVarName = require("./escapeVarName");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function loadDirectory(t, p, state, opts) {
  if (p.node.specifiers.length > 1) {
    throw new Error(`Only default imports are supported. Check the import statement for '${loc}' in ${state.file.opts.filename}`);
  }

  const loc = p.node.source.value;
  const specifier = p.node.specifiers[0];
  const id = specifier.local.name;
  const base = path.dirname(state.file.opts.filename);
  const fullPath = path.join(base, loc);
  const files = fs.readdirSync(fullPath);
  const keys = [];
  const nodes = files.filter(f => !opts.filter || opts.filter.test(f)).map(f => {
    const key = path.basename(f).replace(path.extname(f), '');
    const identifier = t.identifier((0, _escapeVarName.escapeVarName)(key));
    keys.push(identifier);
    let importPath = path.join(path.relative(base, fullPath), f);

    if (!importPath.startsWith('.')) {
      importPath = './' + importPath;
    }

    return t.importDeclaration([t.importNamespaceSpecifier(identifier)], t.stringLiteral(importPath));
  });
  const arrId = t.identifier(id);
  const arrDeclaration = t.variableDeclaration('const', [t.variableDeclarator(arrId, t.arrayExpression(keys))]);
  nodes.push(arrDeclaration);
  p.replaceWithMultiple(nodes);
}